import rison from 'rison';
import utils from './utils.js';

let changeQuery = function (params, query, portletQuery) {
  let href = params.href;
  let passedInAppState = rison.decode(decodeURIComponent(utils.getQueryVariable('_a', href)));

  if (portletQuery.length === 0 || portletQuery === '*') {
    params.localAppState.query.query_string.query = passedInAppState.query.query_string.query = query;
  } else {
    params.localAppState.query.query_string.query = portletQuery + ' AND ' + query;
    passedInAppState.query.query_string.query = portletQuery + ' AND ' + query;
  }

  let indexOfDashSign =  href.indexOf('#');
  let finalUri =   href.substr(indexOfDashSign + 1);
  let replaced = utils.replaceParam(finalUri, '_a', rison.encode(passedInAppState));

  params.$location.url(replaced);

  params.href = replaced;

  params.courier.fetch();
};

let narrow = function (params, items, portletQuery) {
  let result = [];
  for (let key in items) {
    if (items[key].length > 0) {
      let q = key + ':(' + items[key].join(' ') + ')';
      result.push(q);
    }
  }
  changeQuery(params, result.join(' AND '), portletQuery);
};

export default {
  narrow: narrow
};
